unit CustomerBrkdn;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, StdCtrls, TeeGDIPlus,
  TeeComma, TeEngine, TeeProcs, Chart,
  DBChart, ExtCtrls, DB, Series, TeeTools,
  TeeLegendScrollBar, ComCtrls, Mask, Math,
  TeCanvas;

type
  TfrmCustomerBrkdn = class(TForm)
    pnlDBChart: TPanel;
    DBChart: TDBChart;
    TeeCommander1: TTeeCommander;
    Series1: TBarSeries;
    ChartTool1: TLegendScrollBar;
    ScrollBar1: TScrollBar;
    procedure ScrollBar1Change(Sender: TObject);
    procedure ChartTool1Scrolled(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DBChartAfterDraw(Sender: TObject);
    procedure DBChartBeforeDrawChart(Sender: TObject);
  private
    { Private declarations }
    function MaxLegendRows(const YLegend:Integer):Integer;
    function CalcItemHeight:Integer;
    function CalcTotalItems:Integer;
    function GetLegendSeries:TChartSeries;
  public
    { Public declarations }
  end;

var
  frmCustomerBrkdn: TfrmCustomerBrkdn;

implementation

{$R *.dfm}

var chartHeightBefore, chartTopBefore: Integer;

procedure TfrmCustomerBrkdn.ChartTool1Scrolled(Sender: TObject);
begin
  ScrollBar1.Position := ChartTool1.Position;
end;

procedure TfrmCustomerBrkdn.DBChartAfterDraw(Sender: TObject);
begin
  Caption:=IntToStr(MaxLegendRows(DBChart.Legend.Top));
end;

procedure TfrmCustomerBrkdn.DBChartBeforeDrawChart(Sender: TObject);
begin
  chartHeightBefore:=DBChart.ChartHeight;
  chartTopBefore:=DBChart.ChartRect.Top;
end;

procedure TfrmCustomerBrkdn.FormCreate(Sender: TObject);
begin
  DBChart[0].Color := clWebLightSteelBlue;
  DBChart[0].Add(7, '01/04/2004');
  DBChart[0].Add(17,'01/11/2004');
  DBChart[0].Add(6, '01/18/2004');
  DBChart[0].Add(12,'01/25/2004');
  DBChart[0].Add(5, '02/01/2004');
  DBChart[0].Add(7, '02/08/2004');
  DBChart[0].Add(14,'02/15/2004');
  DBChart[0].Add(4, '02/22/2004');
  DBChart[0].Add(12,'03/01/2004');
  DBChart[0].Add(9, '03/08/2004');
  DBChart[0].Add(17,'03/15/2004');
  DBChart[0].Add(2, '03/22/2004');
  DBChart[0].Add(5, '03/29/2004');
  DBChart[0].Add(10,'04/06/2004');
  DBChart[0].Add(6, '04/13/2004');
  DBChart[0].Add(17,'04/20/2004');
  DBChart[0].Add(27,'04/27/2004');
  DBChart[0].Add(16,'05/04/2004');
  DBChart[0].Add(22,'05/11/2004');
  DBChart[0].Add(15,'05/18/2004');
  DBChart[0].Add(17,'05/25/2004');
  DBChart[0].Add(24,'06/01/2004');
  DBChart[0].Add(14,'06/08/2004');
  DBChart[0].Add(22,'06/15/2004');
  DBChart[0].Add(19,'06/22/2004');
  DBChart[0].Add(27,'06/29/2004');
  DBChart[0].Add(12,'07/06/2004');
  DBChart[0].Add(15,'07/13/2004');
  DBChart[0].Add(20,'07/20/2004');
  DBChart[0].Add(16,'07/27/2004');
  DBChart[0].Add(27,'07/03/2004');
  DBChart[0].Add(37,'07/10/2004');
  DBChart[0].Add(26,'07/17/2004');
  DBChart[0].Add(32,'07/24/2004');
  DBChart[0].Add(25,'08/03/2004');
  DBChart[0].Add(27,'08/10/2004');
  DBChart[0].Add(34,'08/17/2004');
  DBChart[0].Add(24,'08/24/2004');
  DBChart[0].Add(32,'08/31/2004');
  DBChart[0].Add(29,'09/07/2004');
  DBChart[0].Add(37,'09/14/2004');
  DBChart[0].Add(22,'09/21/2004');
  DBChart[0].Add(25,'09/28/2004');
  DBChart[0].Add(30,'10/05/2004');
  DBChart[0].Add(26,'10/12/2004');

  DBChart.BottomAxis.SetMinMax(0, 8);

  ScrollBar1.Min := 0;
  ScrollBar1.Max := DBChart[0].Count - 8;
  ScrollBar1.Position := 0;

  DBChart.Draw;
  DBChart.BottomAxis.MinimumOffset := Round(Series1.BarWidth/1.5);
  DBChart.BottomAxis.MaximumOffset := Round(Series1.BarWidth/1.5);

  Series1.AutoBarSize := True;

  ScrollBar1Change(Self);
end;

procedure TfrmCustomerBrkdn.ScrollBar1Change(Sender: TObject);
begin
  DBChart.BottomAxis.SetMinMax(
    ScrollBar1.Position,
    ScrollBar1.Position + 7);

  DBChart.Draw;
  DBChart.BottomAxis.MinimumOffset := Round(Series1.BarWidth/1.5);
  DBChart.BottomAxis.MaximumOffset := Round(Series1.BarWidth/1.5);

  //Workaround
  //if (ScrollBar1.Position) < dbchart[0].count-((dbchart.Legend.LastValue - dbchart.Legend.FirstValue)) then
    ChartTool1.Position := ScrollBar1.Position;
end;

function TfrmCustomerBrkdn.MaxLegendRows(const YLegend:Integer):Integer;
var ItemHeight, FrameWidth: Integer;
begin
  ItemHeight:=CalcItemHeight;

  if DBChart.Legend.Frame.Visible then
    FrameWidth:=DBChart.Legend.Frame.Width
  else
    FrameWidth:=0;

  if (YLegend<DBChart.ChartRect.Bottom) and (ItemHeight>0) then
  Begin
    result:={$IFDEF FMX}Round{$ENDIF}(chartHeightBefore-FrameWidth-YLegend+chartTopBefore) div ItemHeight;
    result:=Math.Min(result,CalcTotalItems);
  end
  else
    result:=0;
end;

function TfrmCustomerBrkdn.CalcItemHeight:Integer;
begin
  DBChart.Canvas.AssignFont(DBChart.Legend.Font);
  result:=DBChart.Canvas.FontHeight;

  with DBChart.Legend do
  begin
    if Symbol.Visible then
       if Symbol.HeightUnits=lcsPercent then
       begin
         if Symbol.Height>100 then
            result:=Round(result*Symbol.Height*0.01);
       end
       else
         result:=Max(result,Symbol.Height);

    if CheckBoxes and (LegendStyle<>lsValues) then
       result:=Max(6+TeeCheckBoxSize,result);

    Inc(result,VertSpacing);

    if Vertical and DividingLines.Visible then
       result:=result+{$IFDEF FMX}Round{$ENDIF}(DividingLines.Width);
  end;
end;

function TfrmCustomerBrkdn.CalcTotalItems:Integer;
var tmpSeries : TChartSeries;
    t         : Integer;
begin
  if DBChart.Legend.Items.Custom then
     result:=DBChart.Legend.Items.Count
  else
  begin
    result:=0;

    if DBChart.Legend.LegendStyle=lsSeriesGroups then
       result:=DBChart.SeriesList.Groups.Count
    else
    if (DBChart.Legend.LegendStyle=lsSeries) or (DBChart.Legend.LegendStyle=lsLastValues) then
    begin
      for t:=0 to DBChart.SeriesCount-1 do
      begin
        With DBChart.Series[t] do
          if (DBChart.Legend.CheckBoxes or Active) and ShowInLegend then
             Inc(result);
      end;

      Dec(result,DBChart.Legend.FirstValue);
    end
    else
    begin
      tmpSeries:=GetLegendSeries;

      if Assigned(tmpSeries) and tmpSeries.ShowInLegend then
      begin
        result:=tmpSeries.CountLegendItems-DBChart.Legend.FirstValue;
      end;
    end;
  end;

  result:=Math.Max(0,result);
end;

function TfrmCustomerBrkdn.GetLegendSeries:TChartSeries;
var t   : Integer;
    tmp : TChartSeries;
begin
  result:=DBChart.Legend.Series;

  if not Assigned(result) then
  begin
    result:=DBChart.GetASeries;

    // If first series has ShowInLegend=False, try to find another one
    if (not Assigned(result)) or (not result.ShowInLegend) then
    for t:=0 to DBChart.SeriesCount-1 do
    begin
      tmp:=DBChart[t];

      if tmp.Active and tmp.ShowInLegend then
      begin
        result:=tmp;
        break;
      end;
    end;
  end;
end;

end.



